#include "../../../lib/std.mi"

//declares volume functions
Function updateVolume(int v);

Global AnimatedLayer Volume;
Global Map volMap;
Global Timer SongTickerTimer;
Global Text SongTicker;
Global Int VolChanging, VolFrames, VolFlag, TickerExist;
Global Group pcGroup;

System.onScriptLoaded() {

	Volume = System.getContainer("main").getLayout("normal").findObject("VolumeAnim");
	SongTicker = System.getContainer("main").getLayout("normal").findObject("songticker");

	SongTickerTimer = new Timer;
	SongTickerTimer.setDelay(750);

	volMap = new Map;
	volMap.loadMap("player.map.volume");

	VolChanging = 0;
	VolFlag = 0;
    VolFrames = Volume.getLength();
    VolFrames = VolFrames - 1;

	float u;
	u = System.getVolume();
	u = u / 255;
	u = u * VolFrames;
	Volume.gotoFrame(u);

}

SongTickerTimer.onTimer() {
  SongTicker.setText("");
  SongTickerTimer.stop();
}

// Reads mouse drag on volume knob
Volume.onMouseMove(int x, int y) {
	if (VolChanging)  {
		x = x - Volume.getLeft();
		y = y - Volume.getTop();

		if (volMap.inRegion(x, y)) {
			float v = volMap.getValue(x, y);
			if (!VolFlag) {
				updateVolume(v);
				if (v > 245) {
					VolFlag = 2;
					updateVolume(255);
				}
				if (v < 10) {
					VolFlag = 1;
					updateVolume(0);
				}
			} else {
				if ((VolFlag == 2) && (v > 120) && (v < 252)) VolFlag = 0;
				if ((VolFlag == 1) && (v < 120) && (v > 2)) VolFlag = 0;
			}
        }
    }
}

// Reads mouse clicks on volume knob
Volume.onLeftButtonDown(int x, int y) {
	VolChanging = 1;
}

Volume.onLeftButtonUp(int x, int y) {
	if (VolChanging) {
		x = x - Volume.getLeft();
		y = y - Volume.getTop();

		if (volMap.inRegion(x, y)) {
			float v = volMap.getValue(x, y);
			if (!VolFlag) {
				updateVolume(v);
				if (v > 245) {
					VolFlag = 2;
					updateVolume(255);
				}
				if (v < 10) {
					VolFlag = 1;
					updateVolume(0);
				}
			} else {
				if ((VolFlag == 2) && (v > 120) && (v < 252)) VolFlag = 0;
				if ((VolFlag == 1) && (v < 120) && (v > 2)) VolFlag = 0;
			}
		}
		VolChanging = 0;
	}
}

// Updates Volume after drag/click
updateVolume(float v) {
	if (v >= 0) {
		float k = v / 255;
		int g = k * VolFrames;
		Volume.gotoFrame(g);
		System.setVolume(v);

		int p = k * 100;
		SongTickerTimer.stop();
		SongTickerTimer.start();
		SongTicker.setText("Volume " + System.integerToString(p) + "%");
     }
}

System.onVolumeChanged(float u) {
	VolFrames = Volume.getLength();
	VolFrames = VolFrames - 1;
	u = System.getVolume();
	u = u / 255;
	int k = u * VolFrames;
	Volume.gotoFrame(k);
}

System.onScriptUnloading() {
	delete SongTickerTimer;
	delete VolMap;
}